#pragma once

#include "NPFile.h"
#include "NPFileFactory.h"

/**
* @ingroup Base Lib
* @brief	ByteArray scope guard helper
* @date		01/11/2007
* @author	telltale
* @remark	
*/
class CNByteArray
{
public:
	CNByteArray() 
	{
		m_pBuf = NULL;
		m_dwBufLen = 0;
	}
	~CNByteArray()
	{
		DestroyBuffer();
	}
	BYTE*	Alloc(DWORD dwBufLen)
	{
		DestroyBuffer();
		m_pBuf = new BYTE[dwBufLen];
		m_dwBufLen = dwBufLen;
		return m_pBuf;
	}
	BYTE*	GetBuffer() { return m_pBuf; }
	DWORD	GetSize() { return m_dwBufLen; }

	static BOOL ReadBufferFromURL(CNByteArray& ByteArray, LPCTSTR pszcURL)
	{
		BOOL bResult = FALSE;
		INPFile* pFile = CNPFileFactory::CreateFileObject(pszcURL);
		if (pFile)
		{
			if (pFile->Open(pszcURL, GENERIC_READ))
			{
				DWORD dwBufLen = static_cast<DWORD>(pFile->GetSize());
				BYTE* pBuf = ByteArray.Alloc(dwBufLen);
				if (pBuf)
				{
					DWORD dwReadLen = pFile->Read(pBuf, dwBufLen);
					ATLASSERT(dwReadLen == dwBufLen);

					bResult = TRUE;
				}
				else
				{
					ATLASSERT(FALSE);
					ATLTRACE(_T("Bytearray alloc error occur in Getlimitsize func\n"));

					bResult = FALSE;
				}
			}
			else
			{
				ATLTRACE(_T("NpFileFactory open fail occur in Getlimitsize func\n"));

				bResult = FALSE;
			}

			CNPFileFactory::DestroyFileObject(pFile);

			return bResult;
		}
		else
		{
			ATLASSERT(FALSE);
			ATLTRACE(_T("NpFileFactory create object error in Getlimitsize func\n"));

			return bResult;
		}
	}
private:
	///< destroy buffer
	void	DestroyBuffer()
	{
		if (m_pBuf)
		{
			delete[] m_pBuf;
			m_pBuf = NULL;
			m_dwBufLen = 0;
		}
	}
	///< buffer
	BYTE*	m_pBuf;
	///< buffer length
	DWORD	m_dwBufLen;
};